# Плагин Subtotal для интеграции SubTotal с WooCommerce

## Системные требования

Php 7.x с установленными расширениями:
- php-mbstring.

## Используемые опции WordPress

### Глобальные

* subtotal_access - куки авторизации, если false отображается страница авторизации
* subtotal_block - блокировка обновления для другого процесса
* subtotal_block_ttl - время жизни блокировки в минутах
* subtotal_cron_update_period - период обновления по расписанию
* subtotal_good_tags - список тегов, полученных от Subtotal, непонятно зачем
* subtotal_import_description - импортировать описание товара при импорте вручную
* subtotal_import_good_tags - импортировать группы товара при импорте по расписанию
* subtotal_import_limit_value - количество товаров, импортируемое за раз
* subtotal_import_photos - импортировать фото товара при импорте вручную
* subtotal_import_pos - точка продаж, на которую приходят заказы
* subtotal_import_price - из какого прайса импортировать цены на товары
* subtotal_import_stores - выгружать остатки по выбранным складам
* subtotal_owner_id - идентификатор владельца бизнеса
* subtotal_owner_url - url магазина в Subtotal
* subtotal_service_tab - показывать вкладку со служебными настройками
* subtotal_update_stocks - обновлять остатки

### К товару

* _subtotal_id - идентификатор товара в Subtotal
* _subtotal_data - данные о товаре, полученные из Subtotal
* _subtotal_updated - дата последнего обновления данных о товаре из Subtotal

## История версий

В следующем выпуске ожидается:

* Ускорение синхронизации
* Добавление журналирования (логирования) в Sentry
* Добавление плагина в официальный репозитарий WordPress

### v0.16

* Исправлена ошибка, когда плагин Subtotal отображался в списке плагинов многократно
* Добавлена система блокировок, допускающая обновление только для одного процесса
* Добавлена логика возобновления синхронизации
* Исправлено двойное созданеие заказа в Subtotal
* Изменена логика загрузки изображений:
  - если изображение было удалено с диска, то оно загружается вновь;
  - добавлено удаление временных файлов с изображениями;
* Интервал между синхронизациями по расписанию увеличен до 1-го часа
* В запросы к Subtotal добавлен таймаут 600 сек.
* Исправлена ошибка синхронизации заказов с модификациями

### v0.15

* Исправлена ошибка синхронизации заказов
* Добавлено кеширование для выгрузки товаров. Можно ещё ускорить, но после тестирования этой версии

### v0.14

* Добавлен костыль, проверяющий коррекное удаление товара (в некоторых случаях после удаления товара оставались метаданные)
* Исправлено добавление товаров в категории
* Добавлена выгрузка техкарт
* Исправлена недоработка синхронизации модификаций
* Добавлена возможность задать URL бэкэнда. Нужно для разработки/тестирования/боя
* Начало рефакторинга табов настроек
* Начало добавления возможности выгрузки остатков по нескольким складам

### v0.13

* Исправлена логика авторизации в Subtotal
* Изменена логика синхронизации товаров
* Полностью удалена логика кеширования при синхронизации
* Удалено логирование на внешний хост
* Удалены настройки для импорта по расписанию: единые настройки для обновлений как вручную, так и по расписанию
* Мелкие правки

### v0.12

* Исправлен баг с поиском пользователя по e-mail
* Исправлен баг с null как аргумента процедуры in_array
* Исправлен баг с несуществующим индексом в массиве $_GET['exit']
* Больше процедур для логирования
* Скрытая вкладка служебных настроек с возможностью включить логирование на внешний хост
* Путь до script.js теперь берётся от wordpress

### v0.11

* Не грузим с subtotal модификации с enable == false

### v0.10

* Пропуск товара, если не получилось его загрузить с Subtotal

## v0.9

* Добавлен параметр no_store_sales для запроса всех товаров вне зависимости от настроек отображения на кассе

### v0.8

* Товар возвращается из корзины при синхронизации
* Исправлен лог после обновления Wordpress до 5.5

### v0.7

* Чекбоксы обёрнуты в label, убрал таблицы для чекбоксов
* Возможность выбрать группы для импорта
* Чекбокс "обновлять остатки"

### v0.6

* Добавлены комментарии для phpDocumentor
* Добавлен README.md

### v0.5

* Исправлено управление запасами для вариаций
* Исправлен баг с обновлением остатков у вариаций (обновлялось только количество для первой вариации)

### v0.4

* Дубли атрибутов в WooCommerce не создаются, если у товара есть глобальный атрибут в WooCommerce.
* В случае наличия глобального атрибута в WooCommerce атрибуты товара из Subtotal  не синхронизируются.

### v0.3

* Троеточие после фраз об импорте, чтобы пользователь понимал что процесс идёт
* Поиск вариации в WooCommerce по имени модификации из Subtotal
* Логирование данных при импорте на внешний сервер

### v0.2

Предполагается два сценария использования:

#### У пользователя всё было в WooCommerce, и он решает использовать Subtotal (вот это было добавлено сейчас)

* Ищется совпадение товара или модификации товара по имени
* Все вариации из WooCommerce становятся товарами Subtotal (и сделать их вариациями нельзя)
* Тип товара в WooCommerce остаётся как есть

Ограничения для товаров Subtotal, которые были вариациями в WooCommerce:

* Нельзя изменить название товара в Subtotal (не будет синхронизировано)
* Нельзя добавить модификации в Subtotal (не будут синхронизированы)
* Нельзя добавить более одного фото (не будут синхронизированы)
* Нельзя добавить группы (не будут синхронизированы)
"Не будут синхронизированы" означает что их смена не создаст каких-то проблем, но синхронизированы конкретно эти изменения не будут
Товары и модификации, которые изначально были добавлены в Subtotal, и уже потом синхронизированы в WooCommerce таких ограничений не имеют.

#### У пользователя всё было в Subtotal, и он решает использовать WooCommerce

* Ускорена синхронизация товаров с вариациями (проверка что такой товар уже синхронизировался в этой сессии)
* Возможность выбрать бизнес
* Увеличен тайм-аут при логине

### v0.1

* Исходная версия

## Authors

sau412@arikado.xyz Царёв Владимир
