<form method="post" action="options.php">
	<?php wp_nonce_field('update-options'); ?>
	<table class="form-table">
		<tr valign="top">
			<th scope="row">Выгружать остатки по следующим складам:</th>
			<td>
				<?php
					foreach ($st_stores as $store_id => $store_name) {
						$checked = '';
						if (in_array($store_id, $wp_stores)) {
							$checked = 'checked';
						}
						$tag_out = '<div><label>';
						$tag_out .= '<input type="radio" name="subtotal_import_stores[]" value="' . $store_id . '" ' . $checked . '>';
						$tag_out .= $store_name;
						$tag_out .= '</label></div>';
						echo $tag_out;
					}
				?>
			</td>
		</tr>
	</table>
	<hr>
	<p>Настройте магазин, чтобы заказы привязывались к определенному магазину в Subtotal. </p>
	<table class="form-table">
		<tr valign="top">
			<th scope="row">Точка, на которую будут приходить заказы:</th>
			<td>
				<select id='pos' name="subtotal_import_pos">
					<?php
						foreach ($st_poses as $pos_id => $pos_name) {
							$selected = '';
							if ($wp_pos == $pos_id) {
								$selected = 'selected';
							}
							$tag_out = '<option value=' . $pos_id . ' ' . $selected . '>';
							$tag_out .= $pos_name;
							$tag_out .= '</option>';
							echo $tag_out;
						}
					?>
				</select>
			</td>
		</tr>
	</table>
	<hr>
	<p>Настройте параметры синхронизации товаров из базы Subtotal</p>
	<table class="form-table">
		<tbody>
			<tr valign="top">
				<th scope="row">Период автообновления (минуты):</th>
				<td>
					<input type="number" min="10" name="subtotal_cron_update_period" placeholder="<?php echo CRON_UPDATE_PERIOD; ?>"
						value="<?php echo get_option('subtotal_cron_update_period'); ?>">
					<p class="description" id="home-description">
						Через этот промежуток времени будут обновляться товары из базы subtotal
					</p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">Импортировать за раз товаров:</th>
				<td><input type="number" name='subtotal_import_limit_value' placeholder="20"
						value="<?php echo get_option('subtotal_import_limit_value'); ?>">
				</td>
				<p class="description" id="home-description"></p>
			</tr>
			<tr valign="top">
				<th scope="row">Импортировать цены из прайса:</th>
				<td>
					<select name='subtotal_import_price'>
						<?php
						foreach ($st_prices as $price_id => $price_name) {
							$selected = '';
							if ($wp_price == $price_id) {
								$selected = 'selected';
							}

							$tag_out = '<option value=' . $price_id . ' ' . $selected . '>';
							$tag_out .= $price_name;
							$tag_out .= '</option>';
							echo $tag_out;
						} ?>
					</select>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">Группы для импорта:</th>
				<td>
					<input
						type='hidden'
						name='subtotal_import_good_tags'
						id='subtotal_import_good_tags'
						value='<?php echo json_encode($wp_good_tags); ?>'>
					<select
						name='subtotal_import_good_tags_visible'
						id='subtotal_import_good_tags_visible'
						multiple
						onChange='jQuery("#subtotal_import_good_tags").val(JSON.stringify(jQuery("#subtotal_import_good_tags_visible").val()))'>
						<?php
						foreach ($st_good_tags as $tag_name) {
							$selected = '';
							if (in_array($tag_name, $wp_good_tags)) {
								$selected = 'selected';
							}
							$tag_out = '<option value="' . $tag_name . '" ' . $selected . '>';
							$tag_out .= $tag_name;
							$tag_out .= '</option>';
							echo $tag_out;
						} ?>
					</select>
					<p class="description" id="home-description">
						Используйте Ctrl или Shift для выбора нескольких групп.
						Если не выбрана ни одна группа будут импортироваться все группы.
					</p>
				</td>
			</tr>
			<tr>
				<td colspan='2'>
					<p>
						<label>
							<input type="checkbox" name='subtotal_update_stocks' <?php echo get_option('subtotal_update_stocks') == 'on' ? 'checked' : ''?>
							>
							Обновлять остатки
						</label>
					</p>
				</td>
			</tr>
		</tbody>
	</table>
	<hr>
	<h4 class="title" style="margin-bottom: 4px;">Настройки ручного импорта</h4>
	<p style="margin-top: 0px;">Эти настройки влияют на ручной импорт через вкладку "Импорт товаров" плагина</p>
	<p>
		<label>
			<input type="checkbox" name='subtotal_import_photos' <?php echo get_option('subtotal_import_photos') == 'on' ? 'checked' : ''; ?>
			>
			Импортировать фотографии
		</label>
		<br>
		<label>
			<input type="checkbox" name='subtotal_import_description' <?php echo get_option('subtotal_import_description') == 'on' ? 'checked' : ''; ?>
			>
			Импортировать описания
		</label>
		<br>
		<label>
			<input type="checkbox" name='subtotal_import_tags' <?php echo get_option('subtotal_import_tags') == 'on' ? 'checked' : ''; ?>
			>
			Импортировать группы
		</label>
		<br>

	</p>
	<hr>
	<input type="hidden" name="action" value="update">
	<?php
	$page_options_array = [
		'subtotal_import_description',
		'subtotal_import_good_tags',
		'subtotal_import_limit_value',
		'subtotal_import_photos',
		'subtotal_import_pos',
		'subtotal_import_price',
		'subtotal_import_stores',
		'subtotal_import_tags',
		'subtotal_cron_update_period',
		'subtotal_update_stocks'
	];
	?>
	<input type="hidden" name="page_options"
		value="<?php echo implode(',', $page_options_array); ?>">

	<p class="submit">
		<input type="submit" class="button-primary"
			value="<?php _e('Save Changes') ?>">
	</p>
</form>