<?php
/**
 * Plugin Name: Subtotal
 * Plugin URI: https://subtotal.ru/support/integraczii/integracziya-s-internet-magazinom-woocommerce
 * Description: Subtotal integration with WooCommerce
 * Author: Subtotal
 * Author URI: https://subtotal.ru
 */
?>
<!-- Профиль -->
<?php
	$access = get_access_info();
	$owner = $access['owner_id'];

	if (get_option('subtotal_import_stores') === false) {
		update_option('subtotal_import_stores', '');
	}
	if (get_option('subtotal_import_pos') === false) {
		update_option('subtotal_import_pos', '');
	}
	if (get_option('subtotal_import_limit_value') === false) {
		update_option('subtotal_import_limit_value', 20);
	}
	if (get_option('subtotal_cron_update_period') === false) {
		update_option('subtotal_cron_update_period', CRON_UPDATE_PERIOD);
	}
	if (get_option('subtotal_import_price') === false) {
		update_option('subtotal_import_price', '');
	}
	if (!is_array(get_option('subtotal_import_good_tags'))) {
		update_option('subtotal_import_good_tags', '');
	}
	if (get_option('subtotal_update_stocks') === false) {
		update_option('subtotal_update_stocks', 'on');
	}
	if (get_option('subtotal_import_photos') === false) {
		update_option('subtotal_import_photos', 'on');
	}
	if (get_option('subtotal_import_description') === false) {
		update_option('subtotal_import_description', 'on');
	}
	if (get_option('subtotal_import_tags') === false) {
		update_option('subtotal_import_tags', 'on');
	}
?>

<b>Аккаунт: <?php echo $access['login']; ?></b>
(<a href="?page=Subtotal&exit=1">выйти</a>) /
<span class="dashicons dashicons-share-alt2"></span>
<a href="https://app.subtotal.ru" target="_blank">Открыть Subtotal</a>

<?php
	$st_stores = st_getStores();
	$wp_stores = get_option('subtotal_import_stores');

	$st_poses = st_getPoses();
	// Точка продаж одна
	$wp_pos = get_option('subtotal_import_pos');

	$st_prices = st_getPriceLists();
	if (isset($st_prices['status']) && !$st_prices['status']) {
		// TODO: пробросить пользователю ошибку из $st_prices['error']
		$st_prices = $st_prices['data'];
	}
	// Прайслист один
	$wp_price = get_option('subtotal_import_price');

	$st_good_tags = st_getGoodTags();
	$wp_good_tags = get_option('subtotal_import_good_tags');

	$nav = !isset($_GET['nav']) ? 'import' : $_GET['nav'];
	$nav_tab = [
		'import' => '',
		'settings' => '',
		'export' => '',
		'shop' => '',
		'debug' => ''
	];
	$nav_tab[$nav] = 'nav-tab-active';
?>
<script type="text/javascript">
	import_limit <?php
	/**
	 * import_limit - глобальная переменная.
	 * Не понятно - или это распространённая практика интероперабельности
	 * WP -> JS (через глобальные переменные), или это простой недочёт.
	 * TODO: разобраться и сделать по уму.
	*/
	?>
		= <?php echo get_option('subtotal_import_limit_value'); ?> ;
</script>
<script type="text/javascript"
	src="<?php echo plugin_dir_url(__FILE__) . 'script.js'; ?>">
	">
</script>
<br><br>
<nav class='nav-tab-wrapper woo-nav-tab-wrapper'>
	<a href='admin.php?page=Subtotal'
		class="nav-tab <?php echo $nav_tab['import']?>">Импорт товаров</a>
	<a href='admin.php?page=Subtotal&nav=settings'
		class="nav-tab <?php echo $nav_tab['settings']?>">Настройки синхронизации</a>
	<a href='admin.php?page=Subtotal&nav=shop'
		class="nav-tab <?php echo $nav_tab['shop']?>">Выбрать бизнес</a>
	<?php
		$subtotal_service_tab = get_option('subtotal_service_tab');
		if ($subtotal_service_tab) {
			echo "<a href='admin.php?page=Subtotal&nav=debug' class=\"nav-tab $nav_tab[debug]\">Служебные настройки</a>";
		} ?>
</nav>
<br>

<?php
/**
 * Текущая реализация импорта - псевдо табы: вроде бы табы, но при смене активного таба,
 * происходит полная перезагрузка страницы без сохранения изменений! TODO: табы!
 */
?>

<?php
// Начало рефакторинга, поэтому некрасиво
if ($nav == 'import') {
	include 'import-page-tab-import.php';
} elseif ($_GET['nav'] == 'settings') {
	include 'import-page-tab-settings.php';
} elseif ($_GET['nav'] == 'shop') {
	$subtotal_shops = st_getShops();
	if ($subtotal_shops->status) {
		// TODO: отобразить ошибку
	} else {
		include 'import-page-tab-shop.php';
	}
} elseif ($_GET['nav'] == 'debug') {
	$subtotal_service_tab = get_option('subtotal_service_tab');
	if ($subtotal_service_tab) {
		$subtotal_service_tab_value = 'checked';
	} else {
		$subtotal_service_tab_value = '';
	}

	include 'import-page-tab-shop.php';
} else {
	echo "<div class='error'>Ошибка авторизации. Нажмите <b><a href=\"?page=Subtotal&exit=1\">выйти</a></b> и авторизуйтесь снова</div>";
}?>

<style type="text/css">
	.blink {
		-webkit-animation: blink 0.7s linear infinite;
		animation: blink 0.7s linear infinite;
	}

	@-webkit-keyframes blink {
		50% {
			color: rgb(34, 34, 34);
		}

		51% {
			color: rgba(34, 34, 34, 0);
		}

		100% {
			color: rgba(34, 34, 34, 0);
		}
	}

	@keyframes blink {
		50% {
			color: rgb(34, 34, 34);
		}

		51% {
			color: rgba(34, 34, 34, 0);
		}

		100% {
			color: rgba(34, 34, 34, 0);
		}
	}
</style>