/* global ajaxurl */

jQuery(document).ready(function($) {
    // Загрузка количества групп
    /**
     * TODO:
     * 1. Брать статистику одним запросом.
     * 2. Обрабатывать ошибки.
     */
    let data = {action: 'st_getCatalogCount', groups: true};
    jQuery.post(ajaxurl, data, function(response) {
        const count = response?.data?.count || 0;
        $('#groupCount').html(count);
    });

    // Загрузка количества товаров
    data = {action: 'st_getCatalogCount'};
    jQuery.post(ajaxurl, data, function(response) {
        const count = response?.data?.count || 0;
        $('#itemsCount').html(count);
    });

    function clearLog() {
        $('#import-log-area').val('');
    }

    function appendLog(str) {
        const date = new Date().toLocaleString();
        const oldLog = $('#import-log-area').val();
        $('#import-log-area').val(`${date} ${str}\n${oldLog}`);
    }

    // let images = [];
    let importSettings = {};
    let imported = 0;

    // Импорт товаров
    function importing(page) {
        $.ajax({
            type: 'POST',
            url: ajaxurl,
            data: {
                action: 'st_importProducts',
                settings: importSettings,
                page_num: page /* eslint camelcase: "off" */
            },
            success: function(result) {
                imported += result?.data?.count || 0;
                // $('#import-progress').attr('value', imported);
                appendLog(`Импорт завершен. Импортировано ${imported} товаров`);
                $('#startImport').attr('disabled', false);
                window.onbeforeunload = null;
            },
            error: function(errorData) {
                /**
                 * TODO:
                 * 1. Вынести в настройки.
                 * 2. Сделать повтор синхронизации прогрессивным:
                 *    после каждой неудачи к таймауту добавлять n-секунд,
                 *    т.о. пауза между попытками будет увеличиваться.
                 * 3. Добавить кнопу для немедленной синхронизации,
                      при прогрессивном повторе.
                 */
                const repeatAfter = 50;
                let logMessage = 'Ошибка импорта';
                const responseText = errorData?.responseJSON?.data;
                if (responseText) {
                    logMessage += `: ${responseText}`;
                }
                appendLog(logMessage);

                // Сообщение о повторе отдельной строкой
                logMessage = `Повтор через ${repeatAfter} секунд...`;
                appendLog(logMessage);

                setTimeout(function() {
                    importing(page);
                }, repeatAfter * 1000);
            },
            dataType: 'json'
        });
    }

    // Запуск импорта
    $('#startImport').click(function() {
        const ele = $('#only_new_products');
        importSettings = {
            only_new_products: ele.attr('checked') == 'checked'
        };

        imported = 0;
        $('#import-log-table').show();
        window.onbeforeunload = function() {
            return 'Вы уверены? Импорт товаров будет прерван.';
        };

        $('#startImport').attr('disabled', true);
        clearLog();
        appendLog('Импорт запущен');
        appendLog('Импорт групп...');
        const params = {action: 'st_importGoodTags'};
        jQuery.post(ajaxurl, params, function() {
            appendLog('Импорт групп завершён.');
            appendLog('Импорт товаров...');
            importing(1);
        });
    });
});
